> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Import a new template document

POST https://example.itential.io/automation-studio/templates/import
Content-Type: application/json

Imports a new template document.

Reference: https://docs.itential.com/itential-platform/6/api-reference/automation-studio/import-templates

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `templates` (list of any or any, optional) — Array of template documents to import. If '_id' is provided, it will be replaced with an autogenerated '_id'. If a template's name is already used in the templates collection, it will be renamed with a numeric suffix.

## Response

### 200

Results from each individual import operation.

- `imported` (list of object, optional)
  - `message` (string, required) — Message containing either confirmation of the import operation or the reason for the failure of the import operation.
  - `original` (any or any, required) — Data to import as a new template document.
  - `created` (object, required, nullable) — The imported template as it exists after being imported.
    - `name` (string, required)
    - `group` (string, required)
    - `command` (string, required)
    - `description` (string, required)
    - `template` (string, required)
    - `data` (string, required)
    - `type` (enum, required)
      - Allowed values: `textfsm`, `jinja2`
    - `_id` (string, optional) — Unique identifier of the automation
    - `namespace` (object, optional)
      - `type` (any, required)
      - `_id` (object, required) — A MongoDB ObjectId
      - `name` (string, required)
    - `createdBy` (string, optional) — Unique identifier of the automation
    - `created` (string, optional)
    - `lastUpdatedBy` (string, optional) — Unique identifier of the automation
    - `lastUpdated` (string, optional)
    - `version` (double, optional)
    - `tags` (list of object, optional)
      - `_id` (string, optional) — Unique identifier of the automation
      - `name` (string, optional) — user-given, unique string to ID tag
  - `edit` (string, required, nullable) — URI to the edit page for the imported template.
  - `success` (boolean, optional) — Status flag denoting the success (true) or failure (false) of the template's import operation.

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "imported": [
    {
      "message": "string",
      "original": {
        "_id": "string",
        "command": "show clock",
        "created": "2019-11-25T22:51:39.201Z",
        "createdBy": "string",
        "data": "Mon Jan 14 18:42:49 2013\ntimezone is US/Central",
        "description": "Arista Show Clock Info",
        "device": "Arista EOS",
        "group": "Arista",
        "lastModifiedBy": "string",
        "lastUpdated": "2019-11-25T22:51:39.201Z",
        "name": "arista_eos_show_clock",
        "projectId": null,
        "tags": [
          {
            "_id": "string",
            "name": "string"
          }
        ],
        "template": "Value TIME (d+:d+:d+)\nValue TIMEZONE (S+)\nValue DAYWEEK (w+)\nValue MONTH (w+)\nValue DAY (d+)\nValue YEAR (d+)\n\nStart\n  ^${DAYWEEK}s+${MONTH}s+${DAY}s+${TIME}s+${YEAR}\n  ^[t|T]imezone(:|sis)s+${TIMEZONE} -> Record\n",
        "text": "Mon Jan 14 18:42:49 2013\ntimezone is US/Central",
        "type": "textfsm",
        "version": 1
      },
      "created": {
        "name": "arista_eos_show_clock",
        "group": "Arista",
        "command": "show clock",
        "description": "Arista Show Clock Info",
        "template": "Value TIME (d+:d+:d+)\nValue TIMEZONE (S+)\nValue DAYWEEK (w+)\nValue MONTH (w+)\nValue DAY (d+)\nValue YEAR (d+)\n\nStart\n  ^${DAYWEEK}s+${MONTH}s+${DAY}s+${TIME}s+${YEAR}\n  ^[t|T]imezone(:|sis)s+${TIMEZONE} -> Record\n",
        "data": "Mon Jan 14 18:42:49 2013\ntimezone is US/Central",
        "type": "textfsm",
        "_id": "string",
        "namespace": {
          "type": null,
          "_id": {},
          "name": "Juniper JUNOS"
        },
        "createdBy": "string",
        "created": "2019-11-25T22:51:39.201Z",
        "lastUpdatedBy": "string",
        "lastUpdated": "2019-11-25T22:51:39.201Z",
        "version": 1,
        "tags": [
          {
            "_id": "string",
            "name": "string"
          }
        ]
      },
      "edit": "string",
      "success": true
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/automation-studio/templates/import"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/automation-studio/templates/import';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/automation-studio/templates/import"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/automation-studio/templates/import")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/automation-studio/templates/import")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/automation-studio/templates/import', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/automation-studio/templates/import");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/automation-studio/templates/import")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```